# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PkceFlowAuthorizationRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'grant_type': 'str',
        'code': 'str',
        'redirect_uri': 'str',
        'refresh_token': 'str',
        'scope': 'str',
        'org_id': 'str',
        'subject_token': 'str',
        'subject_token_type': 'str',
        'code_verifier': 'str'
    }

    attribute_map = {
        'grant_type': 'grant_type',
        'code': 'code',
        'redirect_uri': 'redirect_uri',
        'refresh_token': 'refresh_token',
        'scope': 'scope',
        'org_id': 'org_id',
        'subject_token': 'subject_token',
        'subject_token_type': 'subject_token_type',
        'code_verifier': 'code_verifier'
    }

    def __init__(self, grant_type=None, code=None, redirect_uri=None, refresh_token=None, scope=None, org_id=None, subject_token=None, subject_token_type=None, code_verifier=None):  # noqa: E501
        """PkceFlowAuthorizationRequest - a model defined in Swagger"""  # noqa: E501
        self._grant_type = None
        self._code = None
        self._redirect_uri = None
        self._refresh_token = None
        self._scope = None
        self._org_id = None
        self._subject_token = None
        self._subject_token_type = None
        self._code_verifier = None
        self.discriminator = None
        self.grant_type = grant_type
        if code is not None:
            self.code = code
        if redirect_uri is not None:
            self.redirect_uri = redirect_uri
        if refresh_token is not None:
            self.refresh_token = refresh_token
        if scope is not None:
            self.scope = scope
        if org_id is not None:
            self.org_id = org_id
        if subject_token is not None:
            self.subject_token = subject_token
        if subject_token_type is not None:
            self.subject_token_type = subject_token_type
        if code_verifier is not None:
            self.code_verifier = code_verifier

    @property
    def grant_type(self):
        """Gets the grant_type of this PkceFlowAuthorizationRequest.  # noqa: E501

        OAuth grant types for different use cases.  # noqa: E501

        :return: The grant_type of this PkceFlowAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._grant_type

    @grant_type.setter
    def grant_type(self, grant_type):
        """Sets the grant_type of this PkceFlowAuthorizationRequest.

        OAuth grant types for different use cases.  # noqa: E501

        :param grant_type: The grant_type of this PkceFlowAuthorizationRequest.  # noqa: E501
        :type: str
        """
        if grant_type is None:
            raise ValueError("Invalid value for `grant_type`, must not be `None`")  # noqa: E501

        self._grant_type = grant_type

    @property
    def code(self):
        """Gets the code of this PkceFlowAuthorizationRequest.  # noqa: E501

        Authorization code parameter. Mandatory for grant_type 'authorization_code'.  # noqa: E501

        :return: The code of this PkceFlowAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this PkceFlowAuthorizationRequest.

        Authorization code parameter. Mandatory for grant_type 'authorization_code'.  # noqa: E501

        :param code: The code of this PkceFlowAuthorizationRequest.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def redirect_uri(self):
        """Gets the redirect_uri of this PkceFlowAuthorizationRequest.  # noqa: E501

        Service redirect uri. Mandatory for grant_type 'authorization_code'.  # noqa: E501

        :return: The redirect_uri of this PkceFlowAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._redirect_uri

    @redirect_uri.setter
    def redirect_uri(self, redirect_uri):
        """Sets the redirect_uri of this PkceFlowAuthorizationRequest.

        Service redirect uri. Mandatory for grant_type 'authorization_code'.  # noqa: E501

        :param redirect_uri: The redirect_uri of this PkceFlowAuthorizationRequest.  # noqa: E501
        :type: str
        """

        self._redirect_uri = redirect_uri

    @property
    def refresh_token(self):
        """Gets the refresh_token of this PkceFlowAuthorizationRequest.  # noqa: E501

        Refresh token parameter. Available for grant_type 'refresh_token'.  # noqa: E501

        :return: The refresh_token of this PkceFlowAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._refresh_token

    @refresh_token.setter
    def refresh_token(self, refresh_token):
        """Sets the refresh_token of this PkceFlowAuthorizationRequest.

        Refresh token parameter. Available for grant_type 'refresh_token'.  # noqa: E501

        :param refresh_token: The refresh_token of this PkceFlowAuthorizationRequest.  # noqa: E501
        :type: str
        """

        self._refresh_token = refresh_token

    @property
    def scope(self):
        """Gets the scope of this PkceFlowAuthorizationRequest.  # noqa: E501

        Currently not supported. Present for CSP compatibility.  # noqa: E501

        :return: The scope of this PkceFlowAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._scope

    @scope.setter
    def scope(self, scope):
        """Sets the scope of this PkceFlowAuthorizationRequest.

        Currently not supported. Present for CSP compatibility.  # noqa: E501

        :param scope: The scope of this PkceFlowAuthorizationRequest.  # noqa: E501
        :type: str
        """

        self._scope = scope

    @property
    def org_id(self):
        """Gets the org_id of this PkceFlowAuthorizationRequest.  # noqa: E501

        Unique identifier (GUID) of the organization. Available for grant_type 'client_credentials'.  # noqa: E501

        :return: The org_id of this PkceFlowAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this PkceFlowAuthorizationRequest.

        Unique identifier (GUID) of the organization. Available for grant_type 'client_credentials'.  # noqa: E501

        :param org_id: The org_id of this PkceFlowAuthorizationRequest.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def subject_token(self):
        """Gets the subject_token of this PkceFlowAuthorizationRequest.  # noqa: E501

        Required if the grant_type is 'client_delegate'. A security token that represents the identity of the party on behalf of whom the request is being made. In client_delegate flow, the token provided MUST BE the access token of the user.  # noqa: E501

        :return: The subject_token of this PkceFlowAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._subject_token

    @subject_token.setter
    def subject_token(self, subject_token):
        """Sets the subject_token of this PkceFlowAuthorizationRequest.

        Required if the grant_type is 'client_delegate'. A security token that represents the identity of the party on behalf of whom the request is being made. In client_delegate flow, the token provided MUST BE the access token of the user.  # noqa: E501

        :param subject_token: The subject_token of this PkceFlowAuthorizationRequest.  # noqa: E501
        :type: str
        """

        self._subject_token = subject_token

    @property
    def subject_token_type(self):
        """Gets the subject_token_type of this PkceFlowAuthorizationRequest.  # noqa: E501

        Required if the grant_type is 'client_delegate'. The identifier for the subject token provided as per RFC 8693 https://tools.ietf.org/html/rfc8693#section-3. In 'client_delegate' flow, this value MUST BE 'urn:ietf:params:oauth:token-type:access_token'.  # noqa: E501

        :return: The subject_token_type of this PkceFlowAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._subject_token_type

    @subject_token_type.setter
    def subject_token_type(self, subject_token_type):
        """Sets the subject_token_type of this PkceFlowAuthorizationRequest.

        Required if the grant_type is 'client_delegate'. The identifier for the subject token provided as per RFC 8693 https://tools.ietf.org/html/rfc8693#section-3. In 'client_delegate' flow, this value MUST BE 'urn:ietf:params:oauth:token-type:access_token'.  # noqa: E501

        :param subject_token_type: The subject_token_type of this PkceFlowAuthorizationRequest.  # noqa: E501
        :type: str
        """

        self._subject_token_type = subject_token_type

    @property
    def code_verifier(self):
        """Gets the code_verifier of this PkceFlowAuthorizationRequest.  # noqa: E501

        A high-entropy cryptographic random key using the characters [A-Z] / [a-z] / [0-9] / '-' / '.' / '_' / '~' with a minimum length of 43 characters and a maximum length of 128 characters which was used to generate the 'code_challenge' and obtain the authorization code. Required if PKCE was used in the authorization code grant request. For more information, refer the PKCE RFC at https://tools.ietf.org/html/rfc7636.  # noqa: E501

        :return: The code_verifier of this PkceFlowAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._code_verifier

    @code_verifier.setter
    def code_verifier(self, code_verifier):
        """Sets the code_verifier of this PkceFlowAuthorizationRequest.

        A high-entropy cryptographic random key using the characters [A-Z] / [a-z] / [0-9] / '-' / '.' / '_' / '~' with a minimum length of 43 characters and a maximum length of 128 characters which was used to generate the 'code_challenge' and obtain the authorization code. Required if PKCE was used in the authorization code grant request. For more information, refer the PKCE RFC at https://tools.ietf.org/html/rfc7636.  # noqa: E501

        :param code_verifier: The code_verifier of this PkceFlowAuthorizationRequest.  # noqa: E501
        :type: str
        """

        self._code_verifier = code_verifier

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PkceFlowAuthorizationRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PkceFlowAuthorizationRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
